Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 142831 - [65cat][core] NetBeans needs to accept pac files for proxy settings.
[65cat][core] NetBeans needs to accept pac files for proxy settings.
Status: RESOLVED FIXED
Product: platform
Classification: Unclassified
Component: -- Other --
6.x
All All
: P3 with 1 vote (vote)
: 7.0
Assigned To: Jiri Rechtacek
issues@platform
http://en.wikipedia.org/wiki/Proxy_au...
:
Depends on:
Blocks: 142827
  Show dependency treegraph
 
Reported: 2008-08-04 18:35 UTC by esmithbss
Modified: 2012-01-03 09:18 UTC (History)
4 users (show)

See Also:
Issue Type: ENHANCEMENT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description esmithbss 2008-08-04 18:35:13 UTC
Many organizations use pac files for proxy settings.  In some organizations, the contents of the pac are difficult to
decipher or provide special settings/routings that are not configurable through a simple http or socks proxy.

NetBeans needs to accept PAC files for proxy settings.
Comment 1 Martin Krauskopf 2010-11-03 14:19:01 UTC
I did some research on this topic and this is what I've found out so far (copy-paste from our project's tracker). If you have any other knowledge or comments, whether you would accept Mozilla Rhino version, or you know how to fix this without it, ... please speak-up.

Solution:
---------
The best way was agreed to provide patch to the NetBeans team. But... see 'Implementation problem' section below.

Starting point in NetBeans code-base:
- o.n.core.ui.options.general package in core.ui module
- org.netbeans.core.NbProxySelector class in o.n.core module

Implementation problems:
It is not enough to just evaluate PAC file via JDK scripting API. The bindings must contain functions predefined by the PAC specification[1]. As Mark A. Ziesemer's implementation[2] shows some of those might be implemented in JavaScript but others seemingly cannot. Those which cannot must be implemented in Java and registered/added to the bindings. Unfortunately this is not allowed by JDK scripting API (at least without non-public JDK packages and/or reflection). It is possible with Mozilla Rhino implementation however. So seemingly we will have to bundle Mozilla Rhino implementation. This might make it harder to push the patch to the NetBeans.

Acceptable solution:
Own platform build on top of the patched release691 (or whatever latest stable) branch in 'releases' repository and use it as a base for our application.

Documentation:
--------------
[1] Proxy Client Autoconfig File Format (Specification)
--> http://web.archive.org/web/20060424005037/wp.netscape.com/eng/mozilla/2.0/relnotes/demo/proxy-live.html

[2] Mark A. Ziesemer: MarkUtils-PacProxySelector for Java
--> http://blogger.ziesemer.com/2009/05/markutils-pacproxyselector-java.html

[3] Wikipedia
--> http://en.wikipedia.org/wiki/Proxy_auto-config
Comment 2 Jiri Rechtacek 2011-02-14 16:31:34 UTC
Implemented in NetBeans 7.0 Beta2, since this version NB can detect PAC settings from system and returns network proxy based on this PAC file. On the other hand, there is not new UI in Tools|Options for set PAC file manually. I close as fixed for now, in the case of missing UI please file new issue. Thanks
Comment 3 bhall7 2011-03-04 16:09:00 UTC
I upgraded to Netbeans 7 Beta 2 on Mac OS X, and even though I can access my FTP server and other machines from behind my company's proxy server (for instance, through FileZilla), Netbeans does not allow SVN or FTP/SFTP access using PAC file settings.
Comment 4 Antonin Nebuzelsky 2011-12-28 17:43:49 UTC
I believe this has been evaluated since then. Jirko, what is the status?
Comment 5 Jiri Rechtacek 2012-01-03 09:18:10 UTC
(In reply to comment #3)
> I upgraded to Netbeans 7 Beta 2 on Mac OS X, and even though I can access my
> FTP server and other machines from behind my company's proxy server (for
> instance, through FileZilla), Netbeans does not allow SVN or FTP/SFTP access
> using PAC file settings.

Please, file another issue against versioncontrol/subversion with all details (proxy settings, messages.log etc.) Thanks


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo